import urllib
from BeautifulSoup import BeautifulSoup
import re
import cPickle

def scrape_times(url,n,timelist):
    f = urllib.urlopen(url)
    s = f.read()
    print " read: ", len(s)
    f.close()
    soup = BeautifulSoup(s) 
    table = soup.find("table")
    #n = 1
    for row in table.findAll('tr'):
        col = row.findAll('td')
        rank=col[0].string
        p2case=0

                
        if rank==str(n) or rank==str(n-1) or rank==str(n+1) or rank==str(n-2) or rank==str(n+2):
            #print rank
            r = int(rank)
            nr = col[1].string
            n1 = col[2].string
            n2 = col[3].string
            cl = col[4].string
            sar = col[5].string
            t1 = col[6].string
            t2 = col[7].string
            #print r, " ", nr," n=",n1," n2=",n2," cl=",cl," sar=",sar,
            # print "t1=",t1," t2=",t2
            timepat = re.compile(r'^(\d{1}):(\d{2}):(\d{2})')
            t2s = timepat.search(t1).groups()
            mins = float(t2s[0])*60 + float(t2s[1]) + float(t2s[2])/float(60)
            #print n,": h=",t2s[0], " m=",t2s[1]," s=",t2s[2]," mins=",mins
            #item=[]
            #item.append(mins)
            #item.append(cl)
            #timelist.append(item)
            timelist.append(mins)
            n = n+1

def printtime(mins):
    h = float(mins)/float(60)
    hint = int(h)
    m = (h-hint)*60
    mint = int(m)
    s = (m-mint)*60
    sint = s
    print hint,":",mint,":",sint 
    
if __name__ == "__main__":  
    url_list = []
    n_serie = 15
    beg_first = "http://www.marathon.fi/ilmo2/results_show.php?serie="
    serie =      ["HCM_0_100", "HCM_M_18", "HCM_M_40", "HCM_M_45", "HCM_M_50", "HCM_M_55", "HCM_M_60", "HCM_M_65", "HCM_M_70",
                    "HCM_N_18", "HCM_N_35", "HCM_N_40", "HCM_N_45", "HCM_N_50", "HCM_N_55", "HCM_N_60"]
    Nmax_serie = [5000,         1800,          500,      400,         300 ,         200  ,    100    ,    0      ,    0,
                    500,   100,  200, 100 , 100 , 0, 0 ]
    end_first = "&hcmyear=2010&hcmid=1&base=results_hcm2008"
    first_url = beg_first + serie[n_serie] + end_first
    url_list.append( first_url )
    begin_url= "http://www.marathon.fi/ilmo2/results_show.php?lang=fi&rangestart=" # 100
    end_url = "&nro=&fname=&lname=&teamname=&serie="
    endend_url = "&timeselect=1&hcmyear=2010&hcmid=1"    
    Nmax=Nmax_serie[n_serie]
    n=100
    while (n<=Nmax):
        url = begin_url + str(n) + end_url + serie[n_serie] + endend_url
        n=n+100
        url_list.append( url )
        
    timelist=[]
    n=1
    for myurl in url_list:
        print "scraping: ", myurl
        scrape_times(myurl,n,timelist)
        n=n+100
    print " got ",len(timelist)," times"
    #printtime(timelist[198])
    print " writing file: ",  serie[n_serie]
    cPickle.dump(timelist, open( serie[n_serie] , 'wb')) 
